VERSION 5.00
Begin VB.Form frmTest 
   AutoRedraw      =   -1  'True
   Caption         =   "Test"
   ClientHeight    =   5595
   ClientLeft      =   2280
   ClientTop       =   2160
   ClientWidth     =   8640
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   5595
   ScaleWidth      =   8640
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   495
      Left            =   6600
      TabIndex        =   2
      Top             =   4980
      Width           =   1875
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear"
      Height          =   495
      Left            =   3360
      TabIndex        =   1
      Top             =   4980
      Width           =   1875
   End
   Begin VB.CommandButton cmdTryIt 
      Caption         =   "Try It"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   4980
      Width           =   1875
   End
End
Attribute VB_Name = "frmTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type EmployeeRecord
    EmpName    As String * 20
    DeptNbr    As Integer
    JobTitle   As String * 25
    HireDate   As Date
    HrlyRate   As Single
End Type

Private mudtEmpRecord As EmployeeRecord

Private Sub cmdClear_Click()
    Cls
End Sub


Private Sub cmdExit_Click()
    End
End Sub


Private Sub cmdTryIt_Click()

    Dim strSeqEmpFileName   As String
    Dim strRndEmpFileName   As String
    Dim strBackSlash        As String
    Dim intSeqEmpFileNbr    As Integer
    Dim intRndEmpFileNbr    As Integer
    
    Dim strPrompt           As String
    Dim strNewJob           As String
    
    Dim intRecordCount      As Integer
    Dim strRecordNumber     As String
    Dim intRecordNumber     As Integer
    Dim intX                As Integer
    
    Dim strEmpName    As String
    Dim intDeptNbr    As Integer
    Dim strJobTitle   As String
    Dim dtmHireDate   As Date
    Dim sngHrlyRate   As Single
    
    ' Prepare the file names ...
    strBackSlash = IIf(Right$(App.Path, 1) = "\", "", "\")
    strSeqEmpFileName = App.Path & strBackSlash & "EMPLOYEE.DAT"
    strRndEmpFileName = App.Path & strBackSlash & "EMPLOYEE.RND"
    
    '-----------------------------------------------------------------------
    ' In the first part of this sample program, we will create, or load,
    ' a random access version of the comma-delimited sequential employee
    ' file that was used in one of the sample programs for sequential access
    ' files.
    '-----------------------------------------------------------------------
    
    ' Open the sequential employee file for input ...
    intSeqEmpFileNbr = FreeFile
    Open strSeqEmpFileName For Input As #intSeqEmpFileNbr
    
    ' If the random employee file we want to write already exists,
    ' delete it ...
    If Dir$(strRndEmpFileName) <> "" Then
        Kill strRndEmpFileName
    End If
    ' Open the random employee for writing ...
    intRndEmpFileNbr = FreeFile
    Open strRndEmpFileName For Random Access Write _
        As #intRndEmpFileNbr Len = Len(mudtEmpRecord)
    
    ' Initialize record count variable to keep track of how many records will
    ' be written to the random file ...
    intRecordCount = 0
    
    ' This loop will read a record from the comma-delimited sequential employee file
    ' and write a corresponding record to its random access counterpart ...
    Do Until EOF(intSeqEmpFileNbr)
        ' Read a record's worth of fields from the comma-delimited employee file,
        ' storing the fields into their corresponding variables ...
        Input #intSeqEmpFileNbr, strEmpName, intDeptNbr, strJobTitle, dtmHireDate, sngHrlyRate
        ' Assign each variable read in from the comma-delimited file to its corresponding
        ' field in the mudtEmpRecord record variable (based on the EmployeeRecord UDT).
        ' Note that a With/End With block is used. If With/End With was not used, this set
        ' of assignment statements would have to be written as follows:
        '            mudtEmpRecord.EmpName = strEmpName
        '            mudtEmpRecord.DeptNbr = intDeptNbr
        '            mudtEmpRecord.JobTitle = strJobTitle
        '            mudtEmpRecord.HireDate = dtmHireDate
        '            mudtEmpRecord.HrlyRate = sngHrlyRate
        With mudtEmpRecord
            .EmpName = strEmpName
            .DeptNbr = intDeptNbr
            .JobTitle = strJobTitle
            .HireDate = dtmHireDate
            .HrlyRate = sngHrlyRate
        End With
        ' Now that the record variable has been populated with the proper data,
        ' write the record out to the random file using the Put statement ...
        Put #intRndEmpFileNbr, , mudtEmpRecord
        ' Increment the record count variable ...
        intRecordCount = intRecordCount + 1
    Loop
    
    ' Close the sequential file and the random file ...
    Close #intSeqEmpFileNbr
    Close #intRndEmpFileNbr

    '-----------------------------------------------------------------------
    ' In the next part of this sample program, we will display the records
    ' written to the random file by reading them back and printing their
    ' contents on the form, one by one.
    '-----------------------------------------------------------------------

    ' Print headings on the form ...
    Cls
    Print intRecordCount & " employee records were written to the random file."
    Print "Contents as follows:"
    Print
    Print "EMP NAME"; _
          Tab(25); "DEPT"; _
          Tab(35); "JOB TITLE"; _
          Tab(60); "HIRE DATE"; _
          Tab(70); "HRLY RATE"
    Print "--------"; _
          Tab(25); "----"; _
          Tab(35); "---------"; _
          Tab(60); "---------"; _
          Tab(70); "---------"
          
    ' Open the random file for reading ...
    intRndEmpFileNbr = FreeFile
    Open strRndEmpFileName For Random Access Read _
            As #intRndEmpFileNbr Len = Len(mudtEmpRecord)
    
    ' Since we know how many records are in the file, we can use a For/Next loop
    ' to control the reading and printing of the records ...
    For intX = 1 To intRecordCount
        ' With the Get statement, read the next (or first) record from the
        ' random file, storing its contents in the mudtEmpRecord structure ...
        Get intRndEmpFileNbr, , mudtEmpRecord
        ' Print the data from the record onto the form. Once again, a With/End With
        ' block is used to "factor out" the record variable. If With/End With was
        ' not used, the Print statement would have to be written as follows:
        '    Print mudtEmpRecord.EmpName; _
        '          Tab(25); Format$(mudtEmpRecord.DeptNbr, "@@@@"); _
        '          Tab(35); mudtEmpRecord.JobTitle; _
        '          Tab(60); Format$(mudtEmpRecord.HireDate, "mm/dd/yyyy"); _
        '          Tab(70); Format$(Format$(mudtEmpRecord.HrlyRate, "Standard"), "@@@@@@@")
        With mudtEmpRecord
            Print .EmpName; _
                  Tab(25); Format$(.DeptNbr, "@@@@"); _
                  Tab(35); .JobTitle; _
                  Tab(60); Format$(.HireDate, "mm/dd/yyyy"); _
                  Tab(70); Format$(Format$(.HrlyRate, "Standard"), "@@@@@@@")
        End With
    Next

    ' Close the random file ...
    Close #intRndEmpFileNbr
    
    '-----------------------------------------------------------------------
    ' In the last part of this sample program, we will request an employee
    ' record and then update the job title for that employee.
    '-----------------------------------------------------------------------
    
    ' Prompt the user to enter a valid record number (the record number must be
    ' between 1 and the number of records in the file). The loop below validates
    ' the entry, and re-prompts the user if necessary, before moving on ...
    Do
        strRecordNumber _
            = InputBox("Enter a record number between 1 and " & intRecordCount & ":", _
                       "Random Record Test")
        If strRecordNumber = "" Then Exit Sub   ' user clicked Cancel
        intRecordNumber = Val(strRecordNumber)
        If intRecordNumber < 1 Or intRecordNumber > intRecordCount Then
            MsgBox "Invalid Record Number.", vbExclamation, "Random Record Test"
        End If
    Loop Until intRecordNumber >= 1 And intRecordNumber <= intRecordCount
    
    ' Open the random employee file for read/write access ...
    intRndEmpFileNbr = FreeFile
    Open strRndEmpFileName For Random Access Read Write _
        As #intRndEmpFileNbr Len = Len(mudtEmpRecord)
    
    ' Get the employee record corresponding to the record number entered above ...
    Get #intRndEmpFileNbr, intRecordNumber, mudtEmpRecord
    
    ' Prompt the user to enter a new job title for the employee ...
    strPrompt = "The employee in record # " & intRecordNumber & " is " _
              & Trim$(mudtEmpRecord.EmpName) _
              & ". Enter the new job title for this employee:"
    strNewJob = InputBox(strPrompt, "Update Employee", Trim$(mudtEmpRecord.JobTitle))
    
    ' Display the results
    Print
    If strNewJob = "" Then  ' user clicked Cancel
        Print "Record was not updated."
    Else
        mudtEmpRecord.JobTitle = strNewJob
        Put #intRndEmpFileNbr, intRecordNumber, mudtEmpRecord
        Print "Job title for "; Trim$(mudtEmpRecord.EmpName); _
              " was updated to "; Trim$(mudtEmpRecord.JobTitle) & "."
    End If
    
    ' Close the random file ...
    Close #intRndEmpFileNbr

End Sub

